function getNewHolidayIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('values/holiday');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function storeHolidayParameter(path, value) {
    try 
    {
        lInfo.logln("storeHolidayParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty('values/holiday/' + path, value);
        Property.setFlag('values/holiday/' + path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim storeHolidayParameter " + e + " Path " + path  + " value " + value);
    }        
}

function storeHolidayValue(sValue) {
    try {
        var result =  {};
        var oParameterObject = JSON.parse(unescape(sValue));

        var idValue = null;
        if (oParameterObject.id != null) {
            idValue =  isNaN(parseInt("" + oParameterObject.id)) ? getNewHolidayIdValue() : parseInt("" + oParameterObject.id); 
        } else {
            idValue = getNewHolidayIdValue();
        }
        result.id = idValue;
        var baseNode = Property.getNode('values/holiday');
        if (baseNode != null)
            baseNode.removeChild(idValue);

        //the unescape already ensures to be string
        storeHolidayParameter(idValue + '/name', Utf8.encode(unescape(oParameterObject.name)));
        storeHolidayParameter(idValue + '/id', idValue);
        var startDate = Math.floor((new Date(oParameterObject.von)).getTime()/1000);
        var endDate = Math.floor((new Date(oParameterObject.bis)).getTime()/1000);
        if (!isNaN(startDate) && !isNaN(endDate)) {
            storeHolidayParameter(idValue + '/von', startDate);
            storeHolidayParameter(idValue + '/bis', endDate);
            result.success = true;
        } else {
            //we could not store all data successfully so we cleanup
            baseNode.removeChild(idValue);
            result.success = false;  
        }
    
        var evt = new Event("system-addon-timed-events.config", {actions:'updateTimer'});
        evt.raise();
        return result;
        
    } catch (e) {
        lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
            l.logln(i + ': ' + e[i]);
        }
    }
}


if (raisedEvent.name == 'system-addon-presence-simulator.holiday-config') {
	Property.load();
    if (raisedEvent.parameter.actions == 'save') {
        lInfo.logln("PS-Config Holiday param value " + raisedEvent.parameter.value);       
        var result = storeHolidayValue(raisedEvent.parameter.value);
        var id = result.id;
        Property.store();   
        
        var evt = new Event("system-addon-presence-simulator",  {actions:'checkHoliday'});
        evt.raise();
        var evt2;
        if (result.success) {
            evt2 = new Event("system-addon-presence-simulator.saved", {id:id, complete:'success'});
        } else {
            evt2 = new Event("system-addon-presence-simulator.saved", {id:id, complete:'failed'});
        }
        evt2.raise();
    }
    if (raisedEvent.parameter.actions == 'delete') {
        lInfo.logln("PS-Config Holiday delete value " + raisedEvent.parameter.id);
                
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)=='number')
            oIDObject=[oIDObject];
        
        for (var sKey in oIDObject) {
	        var baseNode = Property.getNode('values/holiday');
	        if (baseNode != null)
	            baseNode.removeChild(oIDObject[sKey]);
        }
        
        Property.store();

        var evt = new Event("system-addon-presence-simulator",  {actions:'checkHoliday'});
        evt.raise();

        var evt2 = new Event("system-addon-presence-simulator.saved",  {id:raisedEvent.parameter.id});
        evt2.raise();
    }
}
    
